#include <stdio.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

main(int ins, char *inputs[]) {
  int objects[10];
  char names[10][80];
  int allfound,found[10]={0,0,0,0,0,0,0,0,0,0};
  FILE *search=NULL;
  extern double atof();
  double epoch,ecc,inc,mean_mo,mean_an,raan,decay,argp;
  int year,int_ecc,cat;
  int dummyd;
  char *point;
  char id[8];
  int last;

  int cont,i,j,end0,end1,end2,inpt;
  char file[255],line[3][255];
  char dig[2];
  FILE *input=NULL,*output=NULL;
  int chksum,end;


  if (ins>1) search=fopen(inputs[1],"r");

  while (search==NULL) {
    printf(" File containing search list> ");
    scanf("%s",file);
    search=fopen(file,"r");
  }

  for (i=0;last!=EOF && i<10;i++) {
    last=fscanf(search,"%s",names[i]);
    last=fscanf(search,"%d",&objects[i]);
    if (last!=EOF) printf(" Will search for %s, ID: %d \n",names[i],
	objects[i]);
  }

  last=i-1;

  if (ins>2) input=fopen(inputs[2],"r");

  while (input==NULL) {
    printf(" Input file name> ");
    scanf("%s",file);
    input=fopen(file,"r");
  }

  for (;;) {
    do {
      inpt=fgets(file,254,input);

      for (end=0;file[end]!='\0' && file[end]!='\n';end++) ;
      end--;
      for (i=end;file[i]==' ';i--) ;
      i++;
      if (file[i]==' ') file[i]='\n';
      i++;
      file[i]='\0';

      end0=end1;
      end1=end2;
      end2=i;

      for (i=0;i<255;i++) line[0][i]=line[1][i];
      for (i=0;i<255;i++) line[1][i]=line[2][i];
      for (i=0;i<255;i++) line[2][i]=   file[i];

      cont= end2!=70 || end1!=70 || end0>20;

      if (inpt==NULL) break;

    } while (cont);

    allfound=1;
    for (i=0;i<last;i++) allfound&=found[i];

    if (allfound || inpt==NULL) break;

    j=0;
    for (i=0;i<68;i++) {
      if (line[1][i]=='-') j+=1;
      if (line[1][i]=='1') j+=1;
      if (line[1][i]=='2') j+=2;
      if (line[1][i]=='3') j+=3;
      if (line[1][i]=='4') j+=4;
      if (line[1][i]=='5') j+=5;
      if (line[1][i]=='6') j+=6;
      if (line[1][i]=='7') j+=7;
      if (line[1][i]=='8') j+=8;
      if (line[1][i]=='9') j+=9;
    }
    chksum= j%10 == atoi(&line[1][i]) && line[1][0]=='1';

    j=0;
    for (i=0;i<68;i++) {
      if (line[2][i]=='1') j+=1;
      if (line[2][i]=='2') j+=2;
      if (line[2][i]=='3') j+=3;
      if (line[2][i]=='4') j+=4;
      if (line[2][i]=='5') j+=5;
      if (line[2][i]=='6') j+=6;
      if (line[2][i]=='7') j+=7;
      if (line[2][i]=='8') j+=8;
      if (line[2][i]=='9') j+=9;
    }
    chksum &= j%10 == atoi(&line[2][i]) && line[2][0]=='2';

    for (j=0;j<last;j++) {
      strncpy(id,line[1]+2,7);
      id[5]='\0';
      dummyd=atoi(id);
      if (dummyd==objects[j]) {

	printf(" Data for satellite %s",line[0]);
	cont=1;
	if (!chksum) {
	  printf(" Checksum error is detected.\n");
	  printf(" Do you want to convert it to HP-48 format? (1/0)\n");
	  scanf("%d",&cont);
	}
	if (cont) {

	  found[j]=1;

	  output=fopen(names[j],"r");
	  strncpy(file,line[1]+18,2);
	  file[2]='\0';
	  year=atoi(file);
	  strncpy(file,line[1]+20,12);
	  file[12]='\0';
	  epoch=atof(file);
	  strncpy(file,line[1]+33,10);
	  file[10]='\0';
	  decay=atof(file);

	  strncpy(file,line[2]+ 8,8);
	  file[8]='\0';
	  inc=atof(file);
	  strncpy(file,line[2]+17,8);
	  file[8]='\0';
	  raan=atof(file);
	  strncpy(file,line[2]+26,7);
	  file[7]='\0';
	  int_ecc=atoi(file);
	  ecc=(double)(int_ecc)*0.0000001;
	  strncpy(file,line[2]+34,8);
	  file[8]='\0';
	  argp=atof(file);
	  strncpy(file,line[2]+43,8);
	  file[8]='\0';
	  mean_an=atof(file);
	  strncpy(file,line[2]+52,11);
	  file[11]='\0';
	  mean_mo=atof(file);

	  output=fopen(names[j],"w");
	  file[0]='%';
	  file[1]='%';
	  fprintf(output,"%c%cHP: T(1)A(D)F(.);\n\
[%3d%13.8f%9.4f%9.4f%10.7f%9.4f%9.4f%12.8f%11.8f ]",
file[0],file[1],year,epoch,inc,raan,ecc,argp,mean_an,mean_mo,decay);
	  fclose(output);
	}
      }
    }
  }
}
